import SwiftUI
import HKDatabase

@main
struct HealthImportApp: App {

    var body: some Scene {
        WindowGroup {
            ContentView()
        }
    }
}

extension HealthDatabase {

    static var shared: HealthDatabase = .init()
}

private extension HealthDatabase {

    static let databaseFileUrl = Bundle.main.url(forResource: "healthdb_secure", withExtension: "sqlite")

    convenience init() {
        let bundleUrl = HealthDatabase.databaseFileUrl!
        let local = FileManager.default.documentDirectory.appendingPathComponent("db.sqlite")
        if !FileManager.default.fileExists(atPath: local.path) {
            try! FileManager.default.copyItem(at: bundleUrl, to: local)
        }
        try! self.init(fileUrl: local)
    }
}

extension FileManager {

    var documentDirectory: URL {
        try! url(
            for: .documentDirectory,
            in: .userDomainMask,
            appropriateFor: nil, create: true)
    }
}
