import Foundation
import HKDatabase

private let df: DateFormatter = {
    let df = DateFormatter()
    df.timeZone = .current
    df.dateStyle = .short
    df.timeStyle = .short
    return df
}()

extension Workout {

    var typeString: String {
        activities.first?.workoutConfiguration.activityType.description ?? "Unknown activity"
    }

    var dateString: String {
        guard let firstAvailableDate else {
            return "No date"
        }
        return df.string(from: firstAvailableDate)
    }

    var firstActivityDate: Date? {
        activities.map { $0.startDate }.min()
    }

    var firstEventDate: Date? {
        events.map { $0.dateInterval.start }.min()
    }

    var firstAvailableDate: Date? {
        [firstEventDate, firstActivityDate].compactMap { $0 }.min()
    }
}
